pcl::IntensitySpinEstimation< PointInT, PointOutT > Class Template Reference
Module features

IntensitySpinEstimation estimates the intensity-domain spin image descriptors for a given point cloud dataset containing points and intensity. More...

`#include <pcl/features/intensity_spin.h>`

Inheritance diagram for pcl::IntensitySpinEstimation< PointInT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< IntensitySpinEstimation< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const IntensitySpinEstimation< PointInT, PointOutT > >
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| IntensitySpinEstimation ()
| Empty constructor. More...
void | computeIntensitySpinImage (const PointCloudIn &cloud, float radius, float sigma, int k, const std::vector< int > &indices, const std::vector< float > &squared_distances, Eigen::MatrixXf &intensity_spin_image)
| Estimate the intensity-domain spin image descriptor for a given point based on its spatial neighborhood of 3D points and their intensities. More...
void | setNrDistanceBins (std::size_t nr_distance_bins)
| Set the number of bins to use in the distance dimension of the spin image. More...
int | getNrDistanceBins ()
| Returns the number of bins in the distance dimension of the spin image. More...
void | setNrIntensityBins (std::size_t nr_intensity_bins)
| Set the number of bins to use in the intensity dimension of the spin image. More...
int | getNrIntensityBins ()
| Returns the number of bins in the intensity dimension of the spin image. More...
void | setSmoothingBandwith (float sigma)
| Set the standard deviation of the Gaussian smoothing kernel to use when constructing the spin images. More...
float | getSmoothingBandwith ()
| Returns the standard deviation of the Gaussian smoothing kernel used to construct the spin images. More...
void | computeFeature (PointCloudOut &output) override
| Estimate the intensity-domain descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), and the spatial locator in setSearchMethod (). More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Public Attributes

int | nr_distance_bins_
| The number of distance bins in the descriptor. More...
int | nr_intensity_bins_
| The number of intensity bins in the descriptor. More...
float | sigma_
| The standard deviation of the Gaussian smoothing kernel used to construct the spin images. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::IntensitySpinEstimation< PointInT, PointOutT >

IntensitySpinEstimation estimates the intensity-domain spin image descriptors for a given point cloud dataset containing points and intensity.

For more information about the intensity-domain spin image descriptor, see:

Svetlana Lazebnik, Cordelia Schmid, and Jean Ponce. A sparse texture representation using local affine regions. In IEEE Transactions on Pattern Analysis and Machine Intelligence, volume 27, pages 1265-1278, August 2005.

Author
  Michael Dixon

Definition at line 58 of file intensity_spin.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT >

using pcl::IntensitySpinEstimation< PointInT, PointOutT >::ConstPtr = shared_ptr<const IntensitySpinEstimation<PointInT, PointOutT> >

Definition at line 62 of file intensity_spin.h.

## PointCloudIn

template<typename PointInT , typename PointOutT >

using pcl::IntensitySpinEstimation< PointInT, PointOutT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 73 of file intensity_spin.h.

## PointCloudOut

template<typename PointInT , typename PointOutT >

using pcl::IntensitySpinEstimation< PointInT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 74 of file intensity_spin.h.

## Ptr

template<typename PointInT , typename PointOutT >

using pcl::IntensitySpinEstimation< PointInT, PointOutT >::Ptr = shared_ptr<IntensitySpinEstimation<PointInT, PointOutT> >

Definition at line 61 of file intensity_spin.h.

## Constructor & Destructor Documentation

## IntensitySpinEstimation()

template<typename PointInT , typename PointOutT >

pcl::IntensitySpinEstimation< PointInT, PointOutT >::IntensitySpinEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 77 of file intensity_spin.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointOutT >

void pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override virtual

Estimate the intensity-domain descriptors at a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface (), and the spatial locator in setSearchMethod ().

Parameters

  [out] | output | the resultant point cloud model dataset that contains the intensity-domain spin image features

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 110 of file intensity_spin.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

## computeIntensitySpinImage()

template<typename PointInT , typename PointOutT >

void pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeIntensitySpinImage | ( | const PointCloudIn & | cloud,
|  | float | radius,
|  | float | sigma,
|  | int | k,
|  | const std::vector< int > & | indices,
|  | const std::vector< float > & | squared_distances,
|  | Eigen::MatrixXf & | intensity_spin_image
| ) |  |

Estimate the intensity-domain spin image descriptor for a given point based on its spatial neighborhood of 3D points and their intensities.

Parameters

  [in] | cloud | the dataset containing the Cartesian coordinates and intensity values of the points
  [in] | radius | the radius of the feature
  [in] | sigma | the standard deviation of the Gaussian smoothing kernel to use during the soft histogram update
  [in] | k | the number of neighbors to use from indices and squared_distances
  [in] | indices | the indices of the points that comprise the query point's neighborhood
  [in] | squared_distances | the squared distances from the query point to each point in the neighborhood
  [out] | intensity_spin_image | the resultant intensity-domain spin image descriptor

Definition at line 48 of file intensity_spin.hpp.

References pcl::PointCloud< PointT >::points.

## getNrDistanceBins()

template<typename PointInT , typename PointOutT >

int pcl::IntensitySpinEstimation< PointInT, PointOutT >::getNrDistanceBins | ( |  | ) |

inline

Returns the number of bins in the distance dimension of the spin image.

Definition at line 107 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_distance_bins_.

## getNrIntensityBins()

template<typename PointInT , typename PointOutT >

int pcl::IntensitySpinEstimation< PointInT, PointOutT >::getNrIntensityBins | ( |  | ) |

inline

Returns the number of bins in the intensity dimension of the spin image.

Definition at line 117 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_intensity_bins_.

## getSmoothingBandwith()

template<typename PointInT , typename PointOutT >

float pcl::IntensitySpinEstimation< PointInT, PointOutT >::getSmoothingBandwith | ( |  | ) |

inline

Returns the standard deviation of the Gaussian smoothing kernel used to construct the spin images.

Definition at line 127 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::sigma_.

## setNrDistanceBins()

template<typename PointInT , typename PointOutT >

void pcl::IntensitySpinEstimation< PointInT, PointOutT >::setNrDistanceBins | ( | std::size_t | nr_distance_bins | ) |

inline

Set the number of bins to use in the distance dimension of the spin image.

Parameters

  [in] | nr_distance_bins | the number of bins to use in the distance dimension of the spin image

Definition at line 103 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_distance_bins_.

## setNrIntensityBins()

template<typename PointInT , typename PointOutT >

void pcl::IntensitySpinEstimation< PointInT, PointOutT >::setNrIntensityBins | ( | std::size_t | nr_intensity_bins | ) |

inline

Set the number of bins to use in the intensity dimension of the spin image.

Parameters

  [in] | nr_intensity_bins | the number of bins to use in the intensity dimension of the spin image

Definition at line 113 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_intensity_bins_.

## setSmoothingBandwith()

template<typename PointInT , typename PointOutT >

void pcl::IntensitySpinEstimation< PointInT, PointOutT >::setSmoothingBandwith | ( | float | sigma | ) |

inline

Set the standard deviation of the Gaussian smoothing kernel to use when constructing the spin images.

Parameters

  [in] | sigma | the standard deviation of the Gaussian smoothing kernel to use when constructing the spin images

Definition at line 123 of file intensity_spin.h.

References pcl::IntensitySpinEstimation< PointInT, PointOutT >::sigma_.

## Member Data Documentation

## nr_distance_bins_

template<typename PointInT , typename PointOutT >

int pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_distance_bins_

The number of distance bins in the descriptor.

Definition at line 138 of file intensity_spin.h.

Referenced by pcl::IntensitySpinEstimation< PointInT, PointOutT >::getNrDistanceBins(), and pcl::IntensitySpinEstimation< PointInT, PointOutT >::setNrDistanceBins().

## nr_intensity_bins_

template<typename PointInT , typename PointOutT >

int pcl::IntensitySpinEstimation< PointInT, PointOutT >::nr_intensity_bins_

The number of intensity bins in the descriptor.

Definition at line 141 of file intensity_spin.h.

Referenced by pcl::IntensitySpinEstimation< PointInT, PointOutT >::getNrIntensityBins(), and pcl::IntensitySpinEstimation< PointInT, PointOutT >::setNrIntensityBins().

## sigma_

template<typename PointInT , typename PointOutT >

float pcl::IntensitySpinEstimation< PointInT, PointOutT >::sigma_

The standard deviation of the Gaussian smoothing kernel used to construct the spin images.

Definition at line 144 of file intensity_spin.h.

Referenced by pcl::IntensitySpinEstimation< PointInT, PointOutT >::getSmoothingBandwith(), and pcl::IntensitySpinEstimation< PointInT, PointOutT >::setSmoothingBandwith().

The documentation for this class was generated from the following files:

- pcl/features/intensity_spin.h
- pcl/features/impl/intensity_spin.hpp